//  AreteEarphoneRfidViewController.m
//  Created by Robin on 16. 8. 22..


#import "AreteRfidViewController.h"
#import "TagViewController.h"
#import "SettingsController.h"
#import "GlobalDefine.h"
#import "AreteRfidAppDelegate.h"
/*SDK header files*/
#import "NFCCommandDefine.h"
#import "ComboDevices.h"
@interface AreteRfidViewController()
{
    int mBatteryVal;
    BOOL mbIsCahrging;
    
}
@property (weak, nonatomic) IBOutlet UILabel                *olLabelConnectState;
@property (weak, nonatomic) IBOutlet UIBarButtonItem        *olBtnOutput;
@property (weak, nonatomic) IBOutlet UILabel                *olTagCount;
@property (weak, nonatomic) IBOutlet UISegmentedControl     *olModeSeg;
@property (weak, nonatomic) IBOutlet UIImageView            *olBattery;
@property (weak, nonatomic) IBOutlet UIButton               *olBtnRead;
@property (weak, nonatomic) IBOutlet UIButton               *olBtnClear;
@property (weak, nonatomic) IBOutlet UIButton               *olBtnStop;
@property (weak, nonatomic) IBOutlet UISwitch               *olSwitch;
@property (nonatomic, strong, readwrite) TagViewController  *tagViewController;
@property (nonatomic, strong, readwrite) SettingsController *settingsController;
@property (nonatomic, retain) ModelSettings                 *m_Model;
@property (nonatomic, retain) CommonDevice                  *m_DeviceCommon;
@property (strong, nonatomic) UIButton        *olBtnSettings;


-(void) updateScanData;
- (IBAction)actionSwitch:(UISwitch *)sender;
- (IBAction)btnRead:(UIButton *)sender;
- (IBAction)btnClear:(UIButton *)sender;
- (IBAction)btnStop:(UIButton *)sender;
- (IBAction)actionModeSeg:(id)sender;
- (IBAction)btnNFCRawdataSend:(id)sender;
@end


@implementation AreteRfidViewController

#pragma mark - segue
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    
    if ([segue.identifier isEqualToString:@"segueTagTableView"])
    {
        self.tagViewController = segue.destinationViewController;
    }
    else if ([segue.identifier isEqualToString:@"segueSettings"])
    {
        self.settingsController = segue.destinationViewController;
    }
    
}


/***********************************************************************/
#pragma mark View life
/***********************************************************************/

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.olBtnSettings = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 50, 30)];
    [self.olBtnSettings setTitle:@"More" forState:UIControlStateNormal];
    [self.olBtnSettings setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
    [self.olBtnSettings addTarget:self action:@selector(morePush) forControlEvents:UIControlEventTouchUpInside];;
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:self.olBtnSettings];
    self.olBtnSettings.userInteractionEnabled = NO;

    /*Go to first screen when background mode*/
    AreteRfidAppDelegate *delegate =(AreteRfidAppDelegate*) [[UIApplication sharedApplication]delegate];
    [delegate registerRootNavigation:self.navigationController];
    
    
    NSDictionary *defaults
    = [NSDictionary dictionaryWithObjectsAndKeys:
       @"YES", @"AutoPowerOn",
       @"YES", @"beep",
       @"YES", @"illumination",
       @"YES", @"vibration",
       @"YES", @"led",
       @"YES", @"powerOnBeep",
       @"YES", @"DefaultTriggerOn",
       @"NO", @"RSSIOn",
       @"NO", @"SymbologyPrefix",
       @"0", @"RFIDScanTagCount",
       @"0", @"RFIDScanTagTime",
       @"0", @"RFIDScanTagInventory",
       @"0", @"RFIDEncoding",
       nil];
    
    [[NSUserDefaults standardUserDefaults]
     registerDefaults:defaults];
    
    
    
    
    
    
    mBatteryVal = 0;
    mbIsCahrging = NO;
    int nTagCount =(int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagCount"];
    int nScanTime =(int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagTime"];
    int nCycle    =(int)[[NSUserDefaults standardUserDefaults] integerForKey:@"RFIDScanTagInventory"];
    
    BOOL isDefaultTriggerOn  = [[NSUserDefaults standardUserDefaults] boolForKey:@"DefaultTriggerOn"];
    [CommonDevice setTriggerModeDefault:isDefaultTriggerOn];
    
    
    CommonDevice *device = [CommonDevice sharedInstance];
    [device setTagCount:nTagCount setSacnTime:nScanTime setCycle:nCycle];
    NSString * displayDisconnectedTime =  [[NSUserDefaults standardUserDefaults] valueForKey:@"DisplayDisconnectedTime"]?:@"0";
    [device setDelayDisconnectOnBackground:[displayDisconnectedTime intValue]];
    
    [[NSNotificationCenter defaultCenter]addObserver:self
                                            selector:@selector(batteryLevelChanged:)
                                                name:UIDeviceBatteryStateDidChangeNotification
                                              object:nil];

}


-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
    
}

-(void)viewDidAppear:(BOOL)animated
{
    self.m_Model         = [ModelSettings sharedInstance];
    self.m_DeviceCommon  = [CommonDevice sharedInstance];
    
    self.m_DeviceCommon.delegateCommon  = self;
    self.m_DeviceCommon.delegateRFID    = self;
    self.m_DeviceCommon.delegateHWEvent = self;
    
    // when Anohter view changed mode by H/W mode change
    [self  updateScanData];
    [UIDevice currentDevice].batteryMonitoringEnabled = YES;
    
}

- (void)morePush {
    [self performSegueWithIdentifier:@"morepush" sender:self];
}

-(void)batteryLevelChanged:(NSNotification *)notification
{
    
    UIDevice* currentDevice = [UIDevice currentDevice];
    UIDeviceBatteryState currentState = [currentDevice batteryState];
    
    if ((currentState == UIDeviceBatteryStateCharging) || (currentState == UIDeviceBatteryStateFull)) {
        mbIsCahrging = YES;
    }
    else
        mbIsCahrging = NO;
    
    int nVal = 0;
    if(mBatteryVal > 95)
        nVal = 4;
    else if(mBatteryVal  >70)
        nVal =3;
    else if(mBatteryVal  >45)
        nVal =2;
    else if(mBatteryVal  > 20)
        nVal =1;
    else
        nVal =0;
    
    NSString *imageName;
    
    if (mbIsCahrging)
        imageName =[NSString stringWithFormat:@"bat_charge_%d.png", nVal];
    else
        imageName =[NSString stringWithFormat:@"bat_normal_%d.png", nVal];
    
    self.olBattery.image = [UIImage imageNamed:imageName];
    
    
}


-(void)viewDidDisappear:(BOOL)animated
{
    [UIDevice currentDevice].batteryMonitoringEnabled = NO;
    //[super viewDidDisappear:YES];
    //[self btnStop:(UIButton*)self];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}


/***********************************************************************/
#pragma mark Delegate
/***********************************************************************/


// Battery info //STEP : 0 , 25, 50 , 75, 100
- (void)adcReceived:(NSData*)data
{
    
    Byte *b    = (Byte*) [data bytes];
    int adc    = b[0];
    
    
    int  nVal         =   (int)adc;
    mBatteryVal =  nVal;
    
    if(nVal > 95)
        nVal = 4;
    else if(nVal  >70)
        nVal =3;
    else if(nVal  >45)
        nVal =2;
    else if(nVal  > 20)
        nVal =1;
    else
        nVal =0;
    
    NSLog(@"Battery %d",adc);
    
    NSString *imageName;
    
    if (mbIsCahrging)
        imageName =[NSString stringWithFormat:@"bat_charge_%d.png", nVal];
    else
        imageName =[NSString stringWithFormat:@"bat_normal_%d.png", nVal];
    
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       
                       self.olBattery.image = [UIImage imageNamed:imageName];
                   });
    
}

//Plug info
- (void)plugged:(BOOL)plug
{
    if(plug)
    {
        NSLog(@"APP plug ON");
        [self plugedState];
        
    }
    else
    {
        NSLog(@"APP plug ONFF");
        [self unPlugedState];
    }
}



 

// recv Scan Data
- (void)receivedScanData:(NSData *)readData DeviceType:(int)nDeviceType
{

    NSMutableString* tag = [[NSMutableString alloc]init] ;
    unsigned char* ptr= (unsigned char*) [readData bytes];
    
    switch (nDeviceType)
    {
        case RCP_COMBO_DEVICE_BARCODE:
            tag = [[NSMutableString alloc] initWithData:readData encoding:NSShiftJISStringEncoding];
            
            if(tag == nil)
            {
                tag = [[NSMutableString alloc] initWithData:readData encoding:NSUTF8StringEncoding];
            }
            
            int nLen =(int)[readData length];
            
            
            NSLog(@"APP : [BARCODE] : %@ %d",tag,nLen);
            break;
            
        case RCP_COMBO_DEVICE_RFID:
            for(int i = 0; i < readData.length; i++)
                [tag appendFormat:@"%02x", *ptr++ & 0xFF ];
            break;
            
        case RCP_COMBO_DEVICE_NFC:
        {
            // NFC DATA FORMAT : STX(1) - ADDR(1) - COMMAND(1) - LEN(1)  - DATA( XX) - ETX(1) - SUM(1) - CR(1)
#define df_NFCDATA_HEADER_SIZE 4
#define df_NFCDATA_FOOTER_SIZE 3
            
            int nNFCDataLen = (int)ptr[3];
            int nTotalSize  = nNFCDataLen+df_NFCDATA_HEADER_SIZE+df_NFCDATA_FOOTER_SIZE;
            
            /* Check Sum */
            Byte btSum = 0x00;
            for(int i = 0; i<nNFCDataLen+df_NFCDATA_HEADER_SIZE+1; i++)
            {
                btSum = (Byte)(btSum+ ptr[i]);
            }
            
            
            //Size Check
            if(nTotalSize != (int)readData.length)
            {
                [tag appendFormat:@"Data Size Err"];
            }
            //Check Sum
            else if(btSum != ptr[df_NFCDATA_HEADER_SIZE+nNFCDataLen+1])
            {
                [tag appendFormat:@"Check Sum Err"];
            }
            //Normal NFC Data
            else if((ptr[0] == 0x02)&&(ptr[df_NFCDATA_HEADER_SIZE+nNFCDataLen] == 0x03)&&(nTotalSize== readData.length))
            {
                for(int i = 0; i<nNFCDataLen; i++)
                    [tag appendFormat:@"%02x", ptr[i+4] & 0xFF ];
            }
            else
            {
                [tag appendFormat:@"Data Format Err"];
            }
            
        }
            break;
            
        default:
            [tag appendFormat:@"Not Found Device Type"];
            break;
    }
    
    
    NSData *data = [[NSData alloc]initWithData:readData];
    [self addScanDataFiltering:tag DeviceType:nDeviceType RawData:data RSSI:0];
    
}

// Scan Data Filtering and Manage Data
-(void)addScanDataFiltering:(NSString*)strScanRead DeviceType:(int)nDeviceType RawData:(NSData*)dataRaw RSSI:(int)nRSSI
{
    
    BOOL isNewData = TRUE;
    
    NSString *strDeviceType = [NSString stringWithFormat:@"%d",nDeviceType];
    
    NSString *strRSSI;
    
    if(nRSSI!=0)
        strRSSI =  [NSString stringWithFormat:@"%d",nRSSI];
    else
        strRSSI = @"";
    
    NSDate *timeDate = [NSDate date];
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"YYYY/MM/dd HH:mm:ss"];
    NSString *dateTime = [formatter stringFromDate:timeDate];
    
    for(int i=0; i<self.m_Model.m_arReadTagData.count;i++)
    {
        NSDictionary *comDic    = [self.m_Model.m_arReadTagData objectAtIndex:i];
        NSString *strCompare    = [comDic objectForKey:df_CELL_TAG_INFO];
        
        if ([strCompare isEqualToString:strScanRead])
        {
            int nCount = [[comDic objectForKey:df_CELL_TAG_COUNT] intValue]+1;
            NSString *strCount = [NSString stringWithFormat:@"%d",nCount];
            
            
            NSDictionary *inserDic  = [NSDictionary dictionaryWithObjectsAndKeys:
                                       strScanRead, df_CELL_TAG_INFO,
                                       strCount, df_CELL_TAG_COUNT,
                                       dataRaw,df_CELL_TAG_RAW,
                                       strRSSI,df_CELL_TAG_RSSI,
                                       strDeviceType,df_CELL_TAG_DEVICETYPE,
                                       dateTime, df_CELL_TAG_DATETIME
                                       ,nil];
            
            if(nDeviceType ==RCP_COMBO_DEVICE_BARCODE)
            {
                NSLog(@"[ Old BARCODE] : %@ %d",dataRaw,(int)dataRaw.length);
            }
            
            [self.m_Model.m_arReadTagData replaceObjectAtIndex:i withObject:inserDic];
            isNewData = FALSE;
            break;
        }
    }
    
    
    if(isNewData)
    {
        //[self playSound:0];
        NSString *strCount = @"1";
        
        if(nDeviceType ==RCP_COMBO_DEVICE_BARCODE)
        {
            NSLog(@"[ New BARCODE] : %@ %d",dataRaw,(int)dataRaw.length);
            
        }
        NSDictionary *inserDic  = [NSDictionary dictionaryWithObjectsAndKeys:
                                   strScanRead, df_CELL_TAG_INFO,
                                   strCount, df_CELL_TAG_COUNT,
                                   dataRaw,df_CELL_TAG_RAW,
                                   strRSSI,df_CELL_TAG_RSSI,
                                   strDeviceType,df_CELL_TAG_DEVICETYPE,
                                   dateTime, df_CELL_TAG_DATETIME
                                   ,nil];
        
        [self.m_Model.m_arReadTagData addObject:inserDic];
    }
    
    [self  updateScanData];
}

// recv  Scand Data include RSSI Data
#pragma mark - RcpRFIDDelegate Method
- (void)pcEpcRssiReceived:(NSData *)pcEpc rssi:(int8_t)rssi
{
    NSMutableString* tag = [[NSMutableString alloc]init] ;
    unsigned char* ptr= (unsigned char*) [pcEpc bytes];
    
    for(int i = 0; i < pcEpc.length; i++)
        [tag appendFormat:@"%02x", *ptr++ & 0xFF ];
    
    [self addScanDataFiltering:tag DeviceType:RCP_COMBO_DEVICE_RFID RawData:pcEpc RSSI:rssi];
    
}

- (void)epcReceived:(NSData *)epc tid:(NSData *)tid
{
    NSMutableString* tag = [[NSMutableString alloc]init] ;
    NSMutableString* tagTid = [[NSMutableString alloc]init] ;
    
    
    unsigned char* ptr= (unsigned char*) [epc bytes];
    unsigned char* ptrTid= (unsigned char*) [tid bytes];
    
    for(int i = 0; i < epc.length; i++)
        [tag appendFormat:@"%02x", *ptr++ & 0xFF ];
    
    for(int i = 0; i < tid.length; i++)
        [tagTid appendFormat:@"%02x", *ptrTid++ & 0xFF ];
    
    NSLog(@" epcReceived EPC: %@ TID: %@ ",tag,tagTid);
}


/***********************************************************************/
#pragma mark IBAction
/***********************************************************************/

-(void) setConnectCommand:(BOOL)isConnect
{
    /* Check stting value (RFID, Barcode) */
    int nSectedType = (int)self.olModeSeg.selectedSegmentIndex;
    BOOL isBeepOn  =[[NSUserDefaults standardUserDefaults] boolForKey:@"beep"];
    BOOL isVirbOn  =[[NSUserDefaults standardUserDefaults] boolForKey:@"vibration"];
    BOOL isLedOn   =[[NSUserDefaults standardUserDefaults] boolForKey:@"led"];
    BOOL isIllumOn =[[NSUserDefaults standardUserDefaults] boolForKey:@"illumination"];
    BOOL isConnectedBeep =[[NSUserDefaults standardUserDefaults] boolForKey:@"powerOnBeep"];
    [[NSUserDefaults standardUserDefaults] setInteger: self.olModeSeg.selectedSegmentIndex  forKey:@"SelectedMode"];
    

   [self.m_DeviceCommon setReaderPower:isConnect buzzer:isBeepOn vibration:isVirbOn led:isLedOn illumination:isIllumOn connectedBeep:isConnectedBeep mode:nSectedType];
        
}

- (IBAction)btnOutput:(id)sender {
    
    dispatch_async(dispatch_get_main_queue(), ^{
        
        NSInteger barCodeCount = 0;
        NSInteger rfidCount = 0;
        for(int i = 0; i < self.m_Model.m_arReadTagData.count; i++) {
            NSDictionary *comDic = [self.m_Model.m_arReadTagData objectAtIndex:i];
            int nDeviceType = [[comDic objectForKey:df_CELL_TAG_DEVICETYPE] intValue];
            switch (nDeviceType) {
                case RCP_COMBO_DEVICE_BARCODE:
                    barCodeCount++;
                    break;
                    
                case RCP_COMBO_DEVICE_RFID:
                    rfidCount++;
                    break;
                default:
                    break;
            }
        }
        
        if (barCodeCount != 0) {
            if ([self isFileExist:@"barcode.csv"]) {
                [self deleteFileForFileName:@"barcode.csv"];
            }
            //创建csv文件
            [self createCSVWithFileName:@"barcode.csv"];
            [self exportCSV:@"barcode.csv"];
        }
        
        if (rfidCount != 0) {
            if ([self isFileExist:@"rfid.csv"]) {
                [self deleteFileForFileName:@"rfid.csv"];
            }
            //创建csv文件
            [self createCSVWithFileName:@"rfid.csv"];
            [self exportCSV:@"rfid.csv"];
        }
    });
}

- (IBAction)actionSwitch:(UISwitch *)sender
{
    UISwitch *sw = (UISwitch*)sender;
    [self setConnectCommand:sw.isOn];
 
    if(sw.isOn)
    {
         [self.olModeSeg setEnabled:NO];
    }
    else
    {
         [self.olModeSeg setEnabled:YES];
    }
    
     [self.olSwitch setEnabled:NO];
    
}

- (IBAction)btnRead:(UIBarButtonItem *)sender
{
    
    CommonReaderInfo *info = [CommonReaderInfo sharedInstance];
    int nTagCount =   info.nCount;
    int nScanTime =   info.nScanTime;
    int nCycle    =   info.nCycle;
    
    BOOL bIsRSSIOn            = [[NSUserDefaults standardUserDefaults] boolForKey:@"RSSIOn"];
    
    int nSelectedDevice = (int)self.olModeSeg.selectedSegmentIndex;
    
    //RFID
    if(nSelectedDevice == RCP_COMBO_DEVICE_RFID)
    {
        ComboRFIDApi *device = [ComboRFIDApi sharedInstance];
        
        if(bIsRSSIOn)
            [device startReadTagsWithRssi:nTagCount mtime:nScanTime repeatCycle:nCycle];
        else
            [device startScan:nTagCount mtime:nScanTime repeatCycle:nCycle];
    }
    
    // NFC
    else if(nSelectedDevice == RCP_COMBO_DEVICE_NFC)
    {
        
        ComboNFCApi *device = [ComboNFCApi sharedInstance];
        [device startScan];
        
    }
    
    // BARCODE
    else if(nSelectedDevice == RCP_COMBO_DEVICE_BARCODE)
    {
        ComboBarcodeApi *device = [ComboBarcodeApi sharedInstance];
        [device startScan];
    }
//20190518 Dual Mode
    else if(nSelectedDevice == RCP_COMBO_DEVICE_DUAL)
    {
        ComboBarcodeApi *device = [ComboBarcodeApi sharedInstance];
        [device startScan];
        
        ComboRFIDApi *deviceRFID = [ComboRFIDApi sharedInstance];
        
        if(bIsRSSIOn)
            [deviceRFID startReadTagsWithRssi:nTagCount mtime:nScanTime repeatCycle:nCycle];
        else
            [deviceRFID startScan:nTagCount mtime:nScanTime repeatCycle:nCycle];
        
        
    }
    
    
}

- (IBAction)btnClear:(UIBarButtonItem *)sender
{
    
    [self.m_Model.m_arReadTagData removeAllObjects];
    [self  updateScanData];
}

- (IBAction)btnStop:(UIBarButtonItem *)sender
{
    
    int nSelectedDevice = (int)self.olModeSeg.selectedSegmentIndex;
    
    if(nSelectedDevice == RCP_COMBO_DEVICE_RFID)
    {
        NSLog(@"App Stop RFID");
        ComboRFIDApi *device = [ComboRFIDApi sharedInstance];
        [device stopScan];
    }
    // NFC
    else if(nSelectedDevice == RCP_COMBO_DEVICE_NFC)
    {
        NSLog(@"App Stop NFC");
        ComboNFCApi *device = [ComboNFCApi sharedInstance];
        [device stopScan];
    }
    
    // 2D
    else if(nSelectedDevice == RCP_COMBO_DEVICE_BARCODE)
    {
        NSLog(@"App Stop Barcode");
        ComboBarcodeApi *device = [ComboBarcodeApi sharedInstance];
        [device stopScan];
    }
//20190518 Dual Mode
    else if(nSelectedDevice == RCP_COMBO_DEVICE_DUAL)
    {
        ComboBarcodeApi *device = [ComboBarcodeApi sharedInstance];
        [device stopScan];
        
        ComboRFIDApi *deviceRFID = [ComboRFIDApi sharedInstance];
        [deviceRFID stopScan];
    }
   
    
}

- (IBAction)actionModeSeg:(id)sender
{
    [self setConnectCommand:NO];
}


/***********************************************************************/
#pragma mark UI Update
/***********************************************************************/

-(void) plugedState
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       self.olSwitch.hidden               = NO;
                       CommonReaderInfo *info              = [CommonReaderInfo sharedInstance];
                       
                       /* Read Save Last connected Device Info*/
                       int nAutoPowerDevice =(int)[[NSUserDefaults standardUserDefaults] integerForKey:@"SelectedMode"];
                       
                       if(info.bIsPowerOn)
                           [self.olLabelConnectState setText:@" Connected "];
                       else
                           [self.olLabelConnectState setText:@" Plugged "];
                       
                       [self.olSwitch setOn:NO];
                       
                       NSLog(@"App Check Device type : %@",info.strName);
                       [self setTitle:info.strName];
                       
                       
                       if(info.bCanUseBarcode)
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:0];
                       else
                           [self.olModeSeg setEnabled:NO  forSegmentAtIndex:0];
                       
                       
                       if(info.bCanUseRFID)
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:1];
                       else
                           [self.olModeSeg setEnabled:NO  forSegmentAtIndex:1];
                       
                       
                       if(info.bCanUseNFC)
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:2];
                       else
                           [self.olModeSeg setEnabled:NO  forSegmentAtIndex:2];
                       
                       
                       int nSelectDevice = nAutoPowerDevice;
                       
//20190518 Dual Mode -20190522(modify)
                       if(info.bDualModeOnAndPreFix)
                       {
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:3];
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:0];
                           [self.olModeSeg setEnabled:YES  forSegmentAtIndex:1];
                           [self.olModeSeg setEnabled:NO  forSegmentAtIndex:2];
                          // nSelectDevice = 3;
                       }
                       else if(nSelectDevice == RCP_COMBO_DEVICE_DUAL)
                       {
                           nSelectDevice = RCP_COMBO_DEVICE_BARCODE;
                           [self.olModeSeg setSelectedSegmentIndex:nSelectDevice];
                           [[NSUserDefaults standardUserDefaults] setInteger: self.olModeSeg.selectedSegmentIndex  forKey:@"SelectedMode"];
                       }
                       
                       
                       
                       //0230D Check
                       if((info.bCanUseBarcode)&&(info.bCanUseRFID))
                       {
                           if(nAutoPowerDevice == RCP_COMBO_DEVICE_NFC)
                               nSelectDevice = RCP_COMBO_DEVICE_BARCODE;
                       }
                       //0240D Check
                       else if((info.bCanUseBarcode)&&(info.bCanUseNFC))
                       {
                           if(nAutoPowerDevice == RCP_COMBO_DEVICE_RFID)
                               nSelectDevice = RCP_COMBO_DEVICE_BARCODE;
                           
                       }
                       else if(info.bCanUseBarcode)
                           nSelectDevice = RCP_COMBO_DEVICE_BARCODE;
                       else if(info.bCanUseRFID)
                           nSelectDevice = RCP_COMBO_DEVICE_RFID;
                       else if(info.bCanUseNFC)
                           nSelectDevice = RCP_COMBO_DEVICE_NFC;
                       
                       [self.olModeSeg setSelectedSegmentIndex:nSelectDevice];
                       
                       BOOL isAutoPower = [[NSUserDefaults standardUserDefaults] boolForKey:@"AutoPowerOn"];
                       if( isAutoPower)
                       {
                           [_olSwitch setOn:YES];
                           [self actionSwitch:_olSwitch];
                       }
                   });
    
}



-(void) unPlugedState
{
    
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self disConnectedState];
                       [self.olLabelConnectState setText:@" UnPlugged "];
                       [self.olSwitch setOn:NO];
                       [self.olSwitch setHidden:YES];
                       [self setTitle:@"Unknown Device"];
                       NSLog(@"App  : %@",@"UnknowDevice");
                       
                       [self.olModeSeg setEnabled:NO  forSegmentAtIndex:0];
                       [self.olModeSeg setEnabled:NO  forSegmentAtIndex:1];
                       [self.olModeSeg setEnabled:NO  forSegmentAtIndex:2];
//20190518 Dual Mode
                       [self.olModeSeg setEnabled:NO  forSegmentAtIndex:3];
                       [self.olModeSeg setSelectedSegmentIndex:0];
                   });
}


-(void) connectedState
{
    [self.olLabelConnectState setTextColor:[UIColor blueColor]];
    [self.olLabelConnectState setText:@" Connected"];
    if(![self.olSwitch isOn])
        [self.olSwitch setOn:YES];
    
    self.olSwitch.hidden        = NO;
    self.olBtnRead.hidden       = NO;
    self.olBtnClear.hidden      = NO;
    self.olBtnStop.hidden       = NO;
    self.olBtnOutput.enabled    = YES;
    self.olBtnSettings.userInteractionEnabled = YES;
    [self.olBtnSettings setTitleColor:[UIColor colorWithRed:8 / 255.f green:112 / 255.f blue:214 / 255.f alpha:1] forState:UIControlStateNormal];
}

-(void) disConnectedState
{
    [self.olLabelConnectState setTextColor:[UIColor redColor]];
    [self.olLabelConnectState setText:@" Disconnected"];
    
    if([self.olSwitch isOn])
        [self.olSwitch setOn:NO];
    
    self.olSwitch.hidden        = NO;
    self.olBtnRead.hidden       = YES;
    self.olBtnClear.hidden      = YES;
    self.olBtnStop.hidden       = YES;
    self.olBtnSettings.userInteractionEnabled = NO;
    [self.olBtnSettings setTitleColor:[UIColor lightGrayColor] forState:UIControlStateNormal];
}



-(void) updateScanData
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self.tagViewController updateData];
                       self.olTagCount.text = [NSString stringWithFormat:@"%d",(int)self.m_Model.m_arReadTagData.count];
                       
                   });
}



/***********************************************************************/
#pragma mark NFC Raw Send / Recieve
/***********************************************************************/

-(IBAction)btnNFCRawdataSend:(id)sender
{
    //Ex ) Inventory Mode set
    ComboNFCApi *device  = [ComboNFCApi sharedInstance];
    Byte cmd[]           = df_NFC_CMD_INVENTORYSET;
    [device sendRawData:cmd len:sizeof(cmd)];
}


- (void)nfcRawDataReceived:(NSData *)rawData
{
    NSLog(@"NFC RAW DATA Receive");
    // you can reiceived command about NFC type
}

- (void)allRawDataReceived:(NSData *)rawData
{
    // you can reiceived command about ALL type
}


/***********************************************************************/
#pragma mark OutputCSV
/***********************************************************************/
- (NSString *) filePath:(NSString *)fileName{
    
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *path = [paths objectAtIndex:0];
    NSString *filePath = [path stringByAppendingPathComponent:fileName];
    return filePath;
}

- (BOOL) isFileExist:(NSString *)fileName {
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    BOOL result = [fileManager fileExistsAtPath:[self filePath:fileName]];
    return result;
}


/* RcpCommonDelegate (Connected status) */
- (void)readerConnected:(uint8_t)status
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self.olSwitch setEnabled:YES];
                     
                       switch (status)
                       {
                           case 0xff:
                           {
                               [self connectedState];
                               /* Combo Model Barcode */
                               ComboBarcodeApi *barcode = [ComboBarcodeApi sharedInstance];
                               BOOL isSymbologyPrefix =[[NSUserDefaults standardUserDefaults] boolForKey:@"SymbologyPrefix"];
                               if(isSymbologyPrefix)
                                   [barcode setSymbologyPrefix];
                               [NSThread sleepForTimeInterval:1.0];
                               [self.olModeSeg setEnabled:YES];
                           }
                               break;
                               
                               
                           default:
                               [self disConnectedState];
                               break;
                               
                       }
                   });
}

- (void) deleteFileForFileName:(NSString *)fileName {
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    [fileManager removeItemAtPath:[self filePath:fileName] error:nil];
}

- (void) createCSVWithFileName:(NSString *)fileName {
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if (![fileManager createFileAtPath:[self filePath:fileName]  contents:nil attributes:nil]) {
    }
};

- (void) exportCSV:(NSString *)fileName {
    
    NSOutputStream *output = [[NSOutputStream alloc] initToFileAtPath:[self filePath:fileName] append:YES];
    [output open];
    
    if (![output hasSpaceAvailable]) {
        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert setMessage:@"Output Error"];
        [alert show];
        return;
    } else {
        NSString *header;
        if ([fileName isEqualToString:@"barcode.csv"]) {
            header = @"barcode,time,count\n";
        } else if ([fileName isEqualToString:@"rfid.csv"]) {
            header = @"pcepc hex,time,count\n";
        }
        const uint8_t *headerString = (const uint8_t *)[header cStringUsingEncoding:NSUTF8StringEncoding];
        NSInteger headerLength = [header lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
        NSInteger result = [output write:headerString maxLength:headerLength];
        if (result <= 0) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
            [alert setMessage:@"Output Error"];
            [alert show];
            return;
        }
        
        for (NSDictionary *inserDic in self.m_Model.m_arReadTagData) {
            
            if ([fileName isEqualToString:@"barcode.csv"] && (RCP_COMBO_DEVICE_BARCODE == [[inserDic objectForKey:df_CELL_TAG_DEVICETYPE] intValue])) {
                NSString *row = [NSString stringWithFormat:@"%@,%@,%@\n", [inserDic objectForKey:df_CELL_TAG_INFO], [inserDic objectForKey:df_CELL_TAG_DATETIME], [inserDic objectForKey:df_CELL_TAG_COUNT]];
                const uint8_t *rowString = (const uint8_t *)[row cStringUsingEncoding:NSUTF8StringEncoding];
                NSInteger rowLength = [row lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
                result = [output write:rowString maxLength:rowLength];
                if (result <= 0) {
                    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
                    [alert setMessage:@"Barcode File Output Error"];
                    [alert show];
                    return;
                }
            } else if ([fileName isEqualToString:@"rfid.csv"] && (RCP_COMBO_DEVICE_RFID == [[inserDic objectForKey:df_CELL_TAG_DEVICETYPE] intValue])) {
                NSString *row = [NSString stringWithFormat:@"%@,%@,%@\n", [inserDic objectForKey:df_CELL_TAG_INFO], [inserDic objectForKey:df_CELL_TAG_DATETIME], [inserDic objectForKey:df_CELL_TAG_COUNT]];
                const uint8_t *rowString = (const uint8_t *)[row cStringUsingEncoding:NSUTF8StringEncoding];
                NSInteger rowLength = [row lengthOfBytesUsingEncoding:NSUTF8StringEncoding];
                result = [output write:rowString maxLength:rowLength];
                if (result <= 0) {
                    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
                    [alert setMessage:@"RFID File Output Error"];
                    [alert show];
                }
            }
            
        }
        if ([fileName isEqualToString:@"barcode.csv"]) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
            [alert setMessage:@"Barcode File Output Success"];
            [alert show];
        } else if ([fileName isEqualToString:@"rfid.csv"]) {
            UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
            [alert setMessage:@"RFID File Output Success"];
            [alert show];
        }
        [output close];
    }
}

/***********************************************************************/
#pragma mark Commbo HW Event
/***********************************************************************/
- (void)resPowerOnOff:(BOOL)isOn Device:(int)nDeviceType IsHWModeChange:(BOOL)bIsHWModeChange
{
    
    //Last selected Divece saved
    [[NSUserDefaults standardUserDefaults] setInteger: self.olModeSeg.selectedSegmentIndex  forKey:@"SelectedMode"];
    
    if(bIsHWModeChange)
    {
        dispatch_async(dispatch_get_main_queue(),
                       ^{
                           [self.olModeSeg setSelectedSegmentIndex:nDeviceType];
                       });
    }
    
    
    
    
    
    
    
}


- (void)pushedTriggerButton
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self setTitle:@"Custom TriggerDown"];
                   });
    
    
}

- (void)releasedTriggerButton
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self setTitle:@"Custom TriggerDownUp"];
                   });
    
}

- (void)checkTriggerStatus:(NSString*)strStatus
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [NSThread sleepForTimeInterval:0.05f];
                       [self setTitle:strStatus];
                   });
    
}

- (void)errReceived:(NSData *)errCode
{
    
    /* Mode Changed Error */
    Byte *b = (Byte*) [errCode bytes];
    if((b[0] == 0x01)&&(b[1] == 0x01)&&(b[2] == 0xE9))
    {
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                    
                       UIAlertView *errorAlert
                       = [[UIAlertView alloc] initWithTitle:@"Error"
                                                    message:@"Error (Mode change)"
                                                   delegate:self
                                          cancelButtonTitle:NSLocalizedString(@"OK", @"")
                                          otherButtonTitles:nil];

                       [errorAlert show];
                   });
    }
}



@end



