//
//  EpcViewController.m
//  AreteCapDongle
//
//  Created by 小田和哉 on 2016/02/15.
//
//

#import "EpcViewController.h"
#import "PhyUtility.h"
#import "ComboDevices.h"
#import "ModelSettings.h"
#import "GlobalDefine.h"
#import "PhyUtility.h"
@interface EpcViewController ()<UITextViewDelegate>
@property (nonatomic,retain)ComboRFIDApi *m_RFIDDevice;
@property (weak, nonatomic) IBOutlet UITextField *targetLabel;
@property (weak, nonatomic) IBOutlet UITextView *inputText;
@property (weak, nonatomic) IBOutlet UITextField *inputHex;
@property (weak, nonatomic) IBOutlet UITextField *hexLabel;
@property (weak, nonatomic) IBOutlet UITextView *MyTextView;

@end

@implementation EpcViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:NO];
    
    self.m_RFIDDevice    = [ComboRFIDApi sharedInstance];
    self.m_RFIDDevice.delegateRFID = self;
    
    ModelSettings *model = [ModelSettings sharedInstance];
    NSDictionary    *dic  = [model.m_arReadTagData objectAtIndex:model.m_nSelectTagNum];
    
    
    NSData *pcEpc = [dic objectForKey:df_CELL_TAG_RAW];
    self.epc = [pcEpc subdataWithRange:NSMakeRange(2, pcEpc.length - 2)];
    self.pcEpc = pcEpc;
    

    self.targetLabel.text   = [self.epc bytesToHexString];;
    self.inputHex.text      = [self.epc bytesToHexString];
    self.inputText.text     = [self.epc bytesToCharString];
    self.MyTextView.text    = @"";
    
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/
- (IBAction)done:(id)sender {
    if ([self.inputText.text isEqualToString:@""]) {
        UIAlertView *alert =  [[UIAlertView alloc]initWithTitle:nil message:@"Please input Data." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
        return;
    }
    
    NSLog(@"pcEpc:%@",self.pcEpc);
    [self.m_RFIDDevice writeToTagMemory:self.pcEpc dataToWriteAscii:self.inputText.text];
    
}

- (void)pcEpcReceived:(NSData *)pcEpc{
    dispatch_async(dispatch_get_main_queue(), ^{
        NSLog(@"pcEpc:%@",pcEpc);
        self.pcEpc = pcEpc;
//        [NSThread sleepForTimeInterval:1.0f];
//       [self.rcp writeToTagMemory:pcEpc dataToWriteAscii:self.inputText.text];
        [self.m_RFIDDevice readFromTagMemory:0x00000000 epc:[self.inputText.text dataUsingEncoding:NSUTF8StringEncoding]
                         memoryBank:0x01 startAddress:0x00 dataLength:0x00];
    });
}

/*
- (void)startedReadTags:(uint8_t)statusCode{
    if (statusCode == 0x1F) {
        dispatch_async(dispatch_get_main_queue(), ^{
            //        [NSThread sleepForTimeInterval:1.0f];
            [self.rcp writeToTagMemory:self.pcEpc dataToWriteAscii:self.inputText.text];
        });
        
        dispatch_async(dispatch_get_main_queue(), ^{
            self.MyTextView.text = [NSString stringWithFormat:@"%@%@",self.MyTextView.text, @"インベントリ完了\n書き込み開始\n"];
        });
    }
}
*/
- (void)writedReceived:(uint8_t)statusCode{
    dispatch_async(dispatch_get_main_queue(), ^{
        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"Writed." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
        
        
        [self.m_RFIDDevice readFromTagMemory:0x00000000 epc:[self.inputText.text dataUsingEncoding:NSUTF8StringEncoding]
                         memoryBank:0x01 startAddress:0x00 dataLength:0x00];
        
    });
}

-(void)tagMemoryReceived:(NSData *)data{
    

    
    dispatch_async(dispatch_get_main_queue(), ^{
        self.pcEpc = [data subdataWithRange:NSMakeRange(2, data.length - 2)];;
        self.epc = [data subdataWithRange:NSMakeRange(4, data.length - 4)];
        /*
        UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:[NSString stringWithFormat:@"Readed.\n%@",self.epc] delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alert show];
        */
        self.targetLabel.text = [self.epc bytesToHexString];
//        self.inputHex.text = [self.epc bytesToHexString];
//        self.inputText.text = [self.epc bytesToCharString];
    });



}

//- (void)errDetailReceived:(NSData *)errCode{
//    
//    if (errCode.length < 3) return;
//    
//    Byte *b = (Byte*) [errCode bytes];
//    
//    NSString *title = @"";
//    
//    if (b[1] == 0x29) {
//        title = @"Read";
//        dispatch_async(dispatch_get_main_queue(), ^{
////            self.targetLabel.text = @"";
//        });
//    }else if (b[1] == 0x46){
//        title = @"Write";
//        dispatch_async(dispatch_get_main_queue(), ^{
////            self.targetLabel.text = @"";
//        });
//    }
//    
//    NSString *strErrMsg = [NSString stringWithFormat:@"Error Code: [0x%02X]\nSub Error Code:[0x%02X]", b[0],b[2]];
//    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:[NSString stringWithFormat:@"%@ Error",title]
//                                                    message:strErrMsg
//                                                   delegate:nil
//                                          cancelButtonTitle:@"OK"
//                                          otherButtonTitles:nil];
//    
//    dispatch_async(dispatch_get_main_queue(),
//                   ^{
//                       [alert show];
//                   });
//}
- (IBAction)changedHex:(id)sender {
    self.inputText.text = [[self.inputHex.text hexStringToBytes] bytesToCharString];
}

- (IBAction)changedText:(id)sender {
    self.inputHex.text = [[NSData dataWithBytes:[self.inputText.text UTF8String] length:[self.inputText.text length]] bytesToHexString];
}

-(BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range replacementText:(NSString *)text{
    
       self.inputHex.text = [[NSData dataWithBytes:[self.inputText.text UTF8String] length:[self.inputText.text length]] bytesToHexString];
    return YES;
}

- (IBAction)copyTarget:(id)sender{
    self.targetLabel.text = self.hexLabel.text;
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.targetLabel resignFirstResponder];
    [self.hexLabel resignFirstResponder];
    [self.inputText resignFirstResponder];
}

@end
