//
//  HoppingViewController.m
//  AsReader 6Combo
//
//  Created by Robin on 2016. 9. 8..
//
//

#import "HoppingViewController.h"
#import "CommonReaderInfo.h"
#import "ComboRFIDApi.h"
#import "CommonDevice.h"
@interface HoppingViewController ()
{
    
}
@property (weak, nonatomic) IBOutlet UILabel *labelInfo;
@property (weak, nonatomic) IBOutlet UISwitch *swOnOff;
@property (weak, nonatomic) IBOutlet UISwitch *swMode;
@property (weak, nonatomic) IBOutlet UIButton *btnStep2;


@property(nonatomic, retain)  ComboRFIDApi       *m_RFIDDevice;
@property(nonatomic, retain)  CommonDevice  *m_CommonDevice;
@property(nonatomic,retain)   UIAlertView *alert;
- (IBAction)actionSwitchHoppingOnOff:(UISwitch *)sender;
-(IBAction)btnStep1:(id)sender;
-(IBAction)btnStep2:(id)sender;
-(IBAction)btnRefleshInfo:(id)sender;
-(IBAction)btnSelectHoppingmode:(id)sender;
@end

@implementation HoppingViewController



-(IBAction)btnSelectHoppingmode:(id)sender
{
    UISwitch *sw = (UISwitch*)sender;
    if(sw.isOn)
    {
        [self showAlert:@"Selected Smart Mode   => push Step2"];
    }
    else
    {
        [self showAlert:@"Selected Normal Mode  => push Step2"];
    }
    
    
}



- (IBAction)actionSwitchHoppingOnOff:(UISwitch *)sender
{
    /* Hopping ON*/
    if(sender.isOn == YES)
    {
        [self.m_RFIDDevice setHoppingOnOff:YES];
        
    }
    /* Hopping OFF */
    else
    {
        [self.m_RFIDDevice setHoppingOnOff:NO];
        
    }
    
}


//reflesh Info
-(IBAction)btnRefleshInfo:(id)sender
{
    [self.m_RFIDDevice GetFrequencyHoppingMode];
    [self.m_RFIDDevice getFhLbtParam];
    
}

//Get Info
- (void)fhLbtReceived:(NSData *)fhLb;
{
    [self getInfo];
    [self showAlert:@"Refreshed Info"];
}

- (void)didSetFhLbt:(uint8_t)status
{
    
    [self showAlert:@"Set FH/LBT Param"];
}


-(void)getInfo
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       
                       CommonReaderInfo *info = [CommonReaderInfo sharedInstance];
                       
                       NSMutableString *strInfo = [[NSMutableString alloc]init];
                       
                       if(info.nFh>info.nLbt)
                       {
                           [strInfo appendString:@"FH ON/OFF : ON"];
                           [self.swOnOff setOn:YES];
                           
                       }
                       else
                       {
                           [strInfo appendString:@"FH ON/OFF : OFF"];
                           [self.swOnOff setOn:NO];
                       }
                       
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"On Time : ",info.nRFIDonTime]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"Off Time : ",info.nRFIDoffTime]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"CST : ",info.nCst]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"FH Val : ",info.nFh]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"RFL : ",info.nRfl]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"LBT : ",info.nLbt]];
                       [strInfo appendString:[NSString stringWithFormat:@"\n %@:%d",@"CW  : ",info.nCw]];
                       
                       if(info.bSmartHopping)
                       {
                           [strInfo appendString:@" FhMode : SMART "];
                           [self.swMode setOn:YES];
                           
                       }
                       else
                       {
                           [strInfo appendString:@" FhMode : NORMAL "];
                           [self.swMode setOn:NO];
                       }
                       [self.labelInfo setText:strInfo];
                       
                   });
}


-(void) showAlert:(NSString*)strMsg
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [self.alert setMessage:strMsg];
                       [self.alert show];
                   });
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
    
    
    
    [self getInfo];
    // Do any additional setup after loading the view.
}

-(void)viewWillAppear:(BOOL)animated
{
    
    self.m_RFIDDevice                  = [ComboRFIDApi sharedInstance];
    self.m_CommonDevice                = [CommonDevice sharedInstance];
    
    self.m_CommonDevice.delegateCommon = self;
    self.m_RFIDDevice.delegateRFID     = self;
    [self performSelector:@selector(onTickGetFHInfo)     withObject:nil afterDelay:0.5f];
    
    
#define DEVICE_ASX_300R      302
    CommonReaderInfo *info = [CommonReaderInfo sharedInstance];
    if(info.m_nReaderType   == DEVICE_ASX_300R)
    {
        
        [self.swMode setHidden:YES];
        [self.btnStep2 setHidden:YES];
        
    }
    else
    {
        [self.swMode setHidden:NO];
        [self.btnStep2 setHidden:NO];
    }
    
}

- (void)resGetFHmode
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       
                       [self getInfo];
                   });
    
    
}

- (void)didSetFHmodeChanged
{
    [self showAlert:@"didSetFhModeChange"];
    
}




- (void) onTickGetFHInfo
{
    
    [self.m_RFIDDevice GetFrequencyHoppingMode];
    
}



- (void)didSetOptiFreqHPTable:(uint8_t)status
{
    if(status == 0x00)
    {
        [self showAlert:@"Wait!! Start OptiMum Freq Start"];
    }
    
    if(status == 0x01)
    {
        [self showAlert:@"Completed Optimum Freq"];
    }
    
}



- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction)btnStep1:(id)sender
{
    [self.m_RFIDDevice setOptimumFrequencyHoppingTable];
}


-(IBAction)btnStep2:(id)sender
{
    BOOL bValue = self.swMode.on;
    
    [self.m_RFIDDevice setSmartHoppingOnOff:bValue];
    
}



- (void)errReceived:(NSData *)errCode{
    Byte *b = (Byte*) [errCode bytes];
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       switch (b[1])
                       {
                           case 0xE4:
                           case 0xE6:
                           case 0xD2:
                           {
                               
                               
                               UIAlertView *errorHopping
                               = [[UIAlertView alloc] initWithTitle:@"Error"
                                                            message:@"The retrun loss of antenna is too large to optimize channel."
                                                           delegate:self
                                                  cancelButtonTitle:NSLocalizedString(@"OK", @"")
                                                  otherButtonTitles:nil];
                               [errorHopping setTag:1];
                               [errorHopping show];
                               
                               break;
                           }
                           default:
                               
                               break;
                       }
                   });
}




@end
