//  SettingsFhLbtController.m

#import "SettingsFhLbtController.h"
#import "ModelSettings.h"

/*SDK header files*/
#import "ComboDevices.h"

@interface SettingsFhLbtController ()<UITextFieldDelegate>
@property (nonatomic,retain)ModelSettings *m_Model;
@end

@implementation SettingsFhLbtController
@synthesize senseTime;
@synthesize lbtLevel;
@synthesize lbtEnable;
@synthesize fhEnable;
@synthesize cwEnable;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.m_Model = [ModelSettings sharedInstance];
    CommonReaderInfo *info = [CommonReaderInfo sharedInstance];
    CommonDevice *device = [CommonDevice sharedInstance];
    device.delegateRFID = self;
    self.olOnTime.text  = [NSString stringWithFormat:@"%d",info.nRFIDonTime];
    self.olOnTime.delegate = self;
    self.olOffTime.text = [NSString stringWithFormat:@"%d",info.nRFIDoffTime];
    self.olOffTime.delegate = self;
}




- (IBAction)rightBarButtonItemClicked:(id)sender
{    
    [self.olOnTime resignFirstResponder];
    [self.olOffTime resignFirstResponder];
    
    int nSetOnTime  = (int)[self.olOnTime.text longLongValue];
    int nSetOffTime = (int)[self.olOffTime.text longLongValue];
    [[ComboRFIDApi sharedInstance]setOnOffTimeSetOnTime:(int)nSetOnTime setOffTeim:(int)nSetOffTime];

}

-(void) showAlert:(NSString*)strMsg
{
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       
                       UIAlertView *alert = [[UIAlertView alloc]initWithTitle:nil message:@"" delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
                       
                       [alert setMessage:strMsg];
                       [alert show];

                       
                   });

}

- (void)onOffTimeChanged
{
     [self showAlert:@"On/OFF Time Changed"];
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



- (void)viewDidUnload {
    [self setOlOnTime:nil];
    [self setOlOffTime:nil];
    [super viewDidUnload];
}



- (BOOL)textField:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string{
    if ([string isEqualToString:@""]) {
        return YES;
    }
    if ([[textField.text stringByAppendingString:string] intValue] >= 40000) {
        textField.text = @"40000";
        return NO;
    }
    return YES;
}

@end
